/*
    HAC - Hack Architecture in C
    Copyright (C) 2012  Dominic Walden

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
  Include file for HAC. Includes a typedef of reg,
  a 16-bit integer which is a type used throughout
  this computer (being a 16-bit computer and all).
*/

#include <stdio.h>

typedef signed short int reg;

/* CPU */
reg addr, datr; //Address and data register
reg mux1, mux2; //Multiplexor 1 and 2
reg pc;         //Program counter
reg ctrl;       //Control thingy
reg reset;      //Reset bit (not implemented yet)

reg outmem;     //Output value of cpu (destined to be stored somewhere)
reg outcond;    //Output condition (is this used?)

reg muxcount;   //Used by addr/addreg function

/* Instruction memory -
   Used to have ROM instruction,
   memory, but not anymore, its
   all part of RAM*/
//reg instmem[20];

/* Data memory */
reg mem[400]; //Memory/RAM

/* Keyboard */
// ???  Not implemented yet

/* Screen */
// ???  Not implemented yet

void alu();

void control();

void addreg();

void datreg();

void progcount();

void muxone();

void muxtwo();

void memory();

void instructions();

void keyboard();
