/*
    Hack computer emulator in C
    Copyright (C) 2012  Dominic Walden

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/* ALU: Takes 3 operands (2 source, 1 destination; destination
   is also one of the sources). */


#include "addresses.h"


void alu()
{

  reg mask = -32768;     //If instruction's
  reg ctl = ctrl & mask; //C bit is on,
                         //interpret it
  if(ctl != 0) {         //as a cpu instruction
                         //rather than as
    mask = 4032;         //an address/constant

  /* Operands/input */
    ctl = ctrl & mask;   //Only count instruction bits

  /* Destinations/output */
    reg * outm = &outmem; //Where output will be stored

  //ctl = ctl >> 6; Ignore this
    /* Process input */
    switch(ctl) {
    case 2688:
      *outm = 0;
      break;
    case 3776:
      *outm = 1;
      break;
    case 3712:
      *outm = -1;
      break;
    case 768:
      *outm = datr;
      break;
    case 3072:
      *outm = mux2;
      break;
    case 832:
      *outm = !datr;
      break;
    case 3136:
      *outm = !mux2;
      break;
    case 960:
      *outm = -datr;
      break;
    case 3264:
      *outm = -mux2;
      break;
    case 1984:
      *outm = datr + 1;
      break;
    case 3520:
      *outm = mux2 + 1;
      break;
    case 896:
      *outm = datr - 1;
      break;
    case 3200:
      *outm = mux2 - 1;
      break;
    case 128:
      *outm = datr + mux2;
      break;
    case 1216:
      *outm = datr - mux2;
      break;
    case 448:
      *outm = mux2 - datr;
      break;
    case 0:
      *outm = datr & mux2;
      break;
    case 1344:
      *outm = datr | mux2;
      break;
  }

  }

}
