/*
    HAC - Hack Architecture in C
    Copyright (C) 2012  Dominic Walden

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
  This is where "machine code" instructions can be coded.
  It has a pointer to mem (memory/RAM) allowing you to put
  the machine code directly to memory. The instructions set
  should be in the README.
*/


#include "addresses.h"



void instructions()
{

  reg * instruction = mem;

  /* -------Ignore this section-------- */

  /* *instruction = 1;
  *(++instruction) = -5104;
  *(++instruction) = 1;
  *(++instruction) = -7416;
  *(++instruction) = 2;
  *(++instruction) = -5104;
  *(++instruction) = 1;
  *(++instruction) = -3952;
  *(++instruction) = 0;
  *(++instruction) = -7416;
  *(++instruction) = -1; */

  /*  *instruction = 1;
  *(++instruction) = -5104;
  *(++instruction) = 0;
  *(++instruction) = -7416; */

  /* *instruction = 0;
  *(++instruction) = -4136; */

  /* *insmem = parser(stream); */

  /* -----It was for testing------- */


  /* ----Code for assembler----- */
  /* Reads from address of "source code",
     matches the ascii value to an entry
     in the symbol table, and adds the
     instruction (integer) to the binary
     data store. When a ; is encountered
     it moves to the next binary store */

  /* Data structure - symbol table
     should be a ascii value followed
     by instruction */
  /*  *(instruction+100) = 43;  
  *(instruction+101) = 128;
  *(instruction+102) = 45;
  *(instruction+103) = 1216; */


  /* "Source code" */
  /*  *(instruction+200) = 43;
  *(instruction+201) = 59;
  *(instruction+202) = 45; */


  /* Instructions */
  /*  instruction = mem;
  *(instruction+199) = 98; //Data structure counter
  *(instruction+299) = 200; //Source code counter
  *(instruction+399) = 300; //Binary data store
  *(instruction+50) = 399; //Address of binary data store
  *(instruction+51) = -568; //Increment bds
  *(instruction+52) = 26; //Address of continuing instructions
  *(instruction+53) = -8185; //Jump

  //Symbol resolution loop:
  *instruction = 299; //Load source code counter
  *(++instruction) = -992; //Value of scc in addr
  *(++instruction) = -1008; //Value of mem[addr] in datr
  *(++instruction) = 199; //Load address of ds counter
  *(++instruction) = -568; //Value of mem[199]+1
  *(++instruction) = -568; //Value of mem[199]+1
  *(++instruction) = -992; //Value of mem[199] stored in addr
  *(++instruction) = -2864; //Datr-mem[addr] stored in datr
  *(++instruction) = 0; //Load address 0
  *(++instruction) = -7419; //If datr!=0 jump
  //End symbol loop
  //Assembling block:
  *(++instruction) = 199; //Address of ds counter
  *(++instruction) = -568; //Increment ds counter
  *(++instruction) = -992; //Value of dsc stored in addr
  *(++instruction) = -1008; //Value of mem[addr] stored in datr
  *(++instruction) = 399; //Load address of binary data store
  *(++instruction) = -992; //Value of bds stored in addr
  *(++instruction) = -3960; //Datr+mem[addr] stored in mem[addr]

  *(++instruction) = 299; //Load scc
  *(++instruction) = -568; //Increment scc
  *(++instruction) = -992; //Value of scc stored in addr
  *(++instruction) = -1008; //Value of mem[addr] stored in datr
  *(++instruction) = 59; //Constant 59
  *(++instruction) = -6960; //Datr-59 stored in datr
  *(++instruction) = 50; //Address 50
  *(++instruction) = -7422; //If datr=0 jump
  *(++instruction) = 98; //Constant 98
  *(++instruction) = -5104; //Store 98 in datr
  *(++instruction) = 199; //Load dsc
  *(++instruction) = -7416; //Store 98 in mem[199]
  *(++instruction) = 299; //Load scc
  *(++instruction) = -568; //Increment scc
  *(++instruction) = -992; //Value of scc stored in addr
  *(++instruction) = -1008; //Mem[addr] stored in datr
  *(++instruction) = 0; //Address 0
  *(++instruction) = -7419; //If datr!=0 jump

  *(++instruction) = -1; //Exit */

  /* -----End of assembler code------ */


  /* -----Code for text editor------- */
  /* Reads from keyboard memory map (address 100), if not a newline
     character, store in memory address pointed to by stack (address
     149), which starts at memory address 150. In other words,
     characters from stdin buffer stored in successive memory addresses
     starting from address 150. */

  *(instruction+149) = 149; //Editor "stack"

  //*instruction = 100; //Load address of keyboard memory map
  //*(++instruction) = -1008; //Store value of mem[addr] in datr
  //*(++instruction) = 0; //Load jump address
  //*(++instruction) = -7422; //If datr == 0 jump
  *instruction = 100; //Load address of keyboard memory map
  *(++instruction) = -1008; //Store value of mem[addr] in datr
  *(++instruction) = 10; //Constant 10 (\n)
  *(++instruction) = -6960; //Datr-addr stored in datr
  *(++instruction) = 13; //Load end of instructions
  *(++instruction) = -7422; //If datr==0 jump
  *(++instruction) = 100; //Load kmm
  *(++instruction) = -1008; //Store value of mem[addr] in datr
  *(++instruction) = 149; //Load address of editor "stack"
  *(++instruction) = -536; //Store value of stack+1 in addr and mem[addr]
  *(++instruction) = -7416; //Store in mem[addr] value in datr
  *(++instruction) = 0; //Load instruction 0
  *(++instruction) = -8185; //Jump
  *(++instruction) = -1; //Exit
  
}
