/*
    HAC - Hack Architecture in C
    Copyright (C) 2012  Dominic Walden

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* Multiplexor 1, accepts input from control and cpu,
   outputs either to addr */

#include "addresses.h"


void muxone()
{

  reg mask = -32768;
  reg ctl = ctrl & mask;
  reg * mux = &mux1;
  reg * muxc = &muxcount;

  /* The addr can store either the value
     of control (an address or constant
     passed as an instruction) or the
     output of the cpu. Mux1 takes care
     of this without addr having to know */
  if(*muxc == 1) {
    *mux = outmem;
    *muxc = 0;
  }

  else if(ctl == 0) {
    mask = 32767;
    ctl = ctrl & mask;

    *mux = ctl;

    *muxc = 0;
  }

  else {
    mask = 32;
    ctl = ctrl & mask;

    if(ctl == 32)
      *muxc = 1;
  }
}
